/*
	BromScript - On Runtime Scripting Language.
    Copyright (C) 2012 - 2013  Alex Brouwer (Bromvlieg: http://brom.4o3.nl/)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <iostream>
#include <string>
#include <tchar.h>
#include <windows.h>
#include <BromScript.h>

using namespace BromScript;
using namespace std;

bool wooperdieloop = true;

BS_ERRORFUNCTION(errfunc){
	printf("BromScript error!\n");

	for (int i = 0; i < stacksize; i++)
		printf("SID: %i, File: %s, Name: %s\n", i, stack[i].Filename, stack[i].Name);

	printf("Message: %s\n", msg);
}

BS_FUNCTION(exit){
	wooperdieloop = false;
	return null;
}

int _tmain(int argc, _TCHAR* argv[]){
	{
		system("Title C++ BromScript");

		Instance bsi;
		bsi.LoadDefaultLibaries(); 

		bsi.SetErrorCallback(errfunc);
		bsi.RegisterFunction("exit", exit);
	
		while(wooperdieloop){
			string str;
			getline (cin,str);

			Variable* var = null;
			try{
				var = bsi.DoString("stdin", str.c_str());
			}catch(CompilerException err){
				printf("Error while compiling line.\nMsg: %s\nLine: %d\n", err.Message, err.CurrentLine);
				continue;
			}

			if (var != null && var->Type != Variable::VariableType::Null){
				printf("Output: ");
			
				List<Variable*> args;
				args.Add(var);
				((Function*)bsi.GetVar("print")->Value)->Run(&args);
			}

			bsi.GC.Run();
		}
	}
	
	return 0;
}